#!/usr/bin/perl -w

### Takes a bunch of filenames, usually generated by make
### Generates a maxima file that:
###	loads all .mxv files
### Eliminated .mac.env route because it (bizarrely) seems to confuse maxima
###	runs commands in .mac files 
###	saves image to a .mxv file
### Make should pipe output to a .out file,
### and provide its name as first argument.

use strict;

my @mxv;
my @mac;

my $target = shift(@ARGV);
$target =~ s/mac\.out$/mxv/ or die "Illegal target $target";

foreach(@ARGV){
	push @mxv, $_ if (/mxv$/ || /env$/);
	push @mac, $_ if /mac$/;
}

foreach(@mxv){
	print "batchload(\"$_\")\$\n";
}

my $save; #Is the last line of the last file a save command?

# Accumulate and print all files.  START and END disabled for now.
foreach my $f (@mac){
	my $text;
	open (INF, $f);
	while(<INF>){
		$text .= $_;
		chomp;
		$save = (/save/ || /stringout/) if $_;
	}
	print $text;
}

print "NOPRINT: stringout(\"$target\", values, functions)\$ /*NOPRINT*/\n" unless $save;
